/************************************************************************/
/*									*/
/*  "device" definition structure					*/
/*									*/
/************************************************************************/

typedef struct device_ {
	struct  device_    *next;	/* chain to next entry 		*/
	double	density;		/* pixels per inch 		*/
	double  zoom_density;		/* (zoom larger, for preview)	*/
	double  aspect_ratio;		/* 1.0 for square pixels 	*/
	char   *stanza_name;		/* name on stanza in "devices"	*/
	char   *dir_name;		/* font subdirectory 		*/
	char   *zoom_dir_name;		/* zoom font subdirectory	*/
	char   *mode_name;		/* METAFONT mode name 		*/
	int     preview;		/* TRUE if previewing 		*/
	int	protocol;		/* type of processing needed 	*/
#                 define  pro_UNDEF      -1     /* undefined            */
#		  define  pro_X11	 0	/* X Windows V11 	*/
#		  define  pro_ps	 1	/* PostScript 		*/
#		  define  pro_pmp        2	/* 3812 pmp 		*/
#		  define  pro_5201       3      /* Quietwriter 		*/
#		  define  pro_4201       4	/* ProPrinter 		*/
#		  define  pro_laserjet   5	/* HP Laserjet 		*/
	} device;
