%{
#include <stdio.h>
#ifndef IBMRT
#include <stdlib.h>
#else
double atof();
#endif
#include "devices.h"
extern device *dev_anchor;
extern char string_value[];
#define  NAME(x) if (0 == strcmp(name,x))
#define  VALUE(x) if (0 == strcmp(value,x))
%}
%token	token header identifier
%start  defn_list
%%
defn_list: 	/* empty */;

defn_list: 	defn_list defn;

defn:		stanza_head spec_list
		{ device *p = dev_anchor;
		  char msg[128]; 
		  if (0.0 >= p->density) {
			sprintf(msg,
				"Invalid density:  \"%g\"",
				p->density);
			error_print(p,msg);
		  } 
		  if (0.0 > p->zoom_density) {
			sprintf(msg,
				"Invalid zoom_density:  \"%g\"",
				p->zoom_density);
			error_print(p,msg);
		  } 
		  if (0.0 >= p->aspect_ratio) {
			sprintf(msg,
				"Invalid aspect_ratio:  \"%g\"",
				p->aspect_ratio);
			error_print(p,msg);
		  } 
		  p->preview = (pro_X11 == p->protocol);
		}

stanza_head:	header_value
		{ device *p = 
		      (device *) calloc(sizeof(device),1);
		  p->next = dev_anchor;
		  dev_anchor = p;
		  p->stanza_name = (char *) $1;
		  p->protocol = pro_UNDEF; }

header_value:	header
		{ char *p = (char *) malloc(strlen(string_value)+1);
		  strcpy(p,string_value);
		  $$ = (int) p; }

spec_list: 	/* empty */ ;

spec_list: 	spec_list spec;

spec:		spec_head token_value
		{ device *p = dev_anchor;
		  char *name = (char *) $1;
		  char *value = (char *) $2;
		  NAME("density") 
			p->density = atof(value);
		  else NAME("zoom_density")
			p->zoom_density = atof(value);
		  else NAME("aspect_ratio")
			p->aspect_ratio = atof(value);
		  else NAME("dir_name")
			p->dir_name = value;
		  else NAME("zoom_dir_name")
			p->zoom_dir_name = value;
		  else NAME("mode_name")
			p->mode_name = value;
		  else NAME("protocol") {
			lower_case(value);
			VALUE("x11")
				p->protocol = pro_X11;
			else VALUE("postscript")
				p->protocol = pro_ps;
			else VALUE("pmp")
				p->protocol = pro_pmp;
			else VALUE("5201")
				p->protocol = pro_5201;
			else VALUE("4201")
				p->protocol = pro_4201;
			else VALUE("laserjet")
				p->protocol = pro_laserjet;
		  }
		}

spec_head:	identifier
		{ char *p = (char *) malloc(strlen(string_value)+1);
		  strcpy(p,string_value);
		  $$ = (int) p; }

token_value:	token
		{ char *p = (char *) malloc(strlen(string_value)+1);
		  strcpy(p,string_value);
		  $$ = (int) p; }
%%
error_print(p,msg)
device *p;
char *msg;
{
	fprintf(stderr,
		"Error in stanza for device \"%s\":  %s\n",
		p->stanza_name,
		msg);
}

lower_case(s)
char *s;
{
	char  c;
	while ((c = *s) != '\0') {
		if (('A' <= c) && ('Z' >= c)) 
			*s = c + ('a' - 'A');
		s++;
	}
}
	
